#version 120

uniform sampler2D image;
uniform vec2 size;
uniform vec2 BlurDir;
uniform float pixel;
uniform float Radius;
//To those who are looking, I know this isn't guass.

void main() {
    vec4 blurred = vec4(0.0);
    float totalStrength = 0.0;
    float totalAlpha = 0.0;
    float totalSamples = 0.0;
    vec2 uv = gl_FragCoord.xy/size;
    for (float r = -Radius; r <= Radius; r += 1.0) {
        vec4 Sample = texture2D(image, uv + pixel * r * BlurDir);

        // Accumulate average alpha
        totalAlpha = totalAlpha + Sample.a;
        totalSamples = totalSamples + 1.0;

        // Accumulate smoothed blur
        float strength = 1.0 - abs(r / Radius);
        totalStrength = totalStrength + strength;
        blurred = blurred + Sample;
    }
    gl_FragColor = vec4(blurred.rgb / (Radius * 2.0 + 1.0), totalAlpha);
}