#version 330 core

uniform vec2 size;
uniform sampler2D screenTexture;
uniform float time;

float offset_x = 1.0f / size.x;
float offset_y = 1.0f / size.y;

vec2 offsets[9] = vec2[]
(
vec2(-offset_x,  offset_y), vec2( 0.0f,    offset_y), vec2( offset_x,  offset_y),
vec2(-offset_x,  0.0f),     vec2( 0.0f,    0.0f),     vec2( offset_x,  0.0f),
vec2(-offset_x, -offset_y), vec2( 0.0f,   -offset_y), vec2( offset_x, -offset_y)
);

float kernel[9] = float[]
(
1, 1, 1,
1, -8, 1,
1, 1, 1
);

vec3 hsb2rgb( in vec3 c ){
    vec3 rgb = clamp(abs(mod(c.x*6.0+vec3(0.0,4.0,2.0),6.0)-3.0)-1.0,0.0,1.0);
    rgb = rgb*rgb*(3.0-2.0*rgb);
    return c.z * mix( vec3(1.0), rgb, c.y);
}

void main()
{
    vec2 uv = gl_FragCoord.xy/size;
    vec4 color = vec4(0.0f);
    for(int i = 0; i < 9; i++)
    color += vec4(texture(screenTexture, uv + offsets[i])) * kernel[i];
    //uncomment this if you want the shader esp to be rainbow
//    color += vec4(hsb2rgb(vec3(1 * time + (uv.x + uv.y)*.5, 0.35, 1)), 0);
    gl_FragColor = vec4(color);
}